/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.mail;

import java.util.Map;

import org.springframework.mail.SimpleMailMessage;

/**
 * MailService provides a simple abstraction for an Email sending service
 *
 * @author Timo Westk&auml;mper
 */
public interface MailService {
    
    /**
     * Send the message described via subject and body to the given recipient
     * 
     * @param recipient
     * @param subject
     * @param body
     */
    public void sendMessage(String recipient, String subject, String body);
    
    /**
     * Send the message describe via subject and body to the given recipients
     * 
     * @param recipients
     * @param subject
     * @param body
     */
    public void sendMessage(String[] recipients, String subject, String body);
    
    /**
     * 
     * @param recipient
     * @param subject
     * @param body
     */
    public void sendHTMLMessage(String recipient, String subject, String body);
    
    /**
     * 
     * @param recipients
     * @param subject
     * @param body
     */
    public void sendHTMLMessage(String[] recipients, String subject, String body);
    
    /**
     *  
     * @param recipient
     * @param subject
     * @param template
     * @param model
     */
    public void sendMessage(String recipient, String subject, String template, Map<String,?> model);
    
    /**
     * @param recipients
     * @param subject
     * @param template
     * @param model
     */
    public void sendMessage(String[] recipients, String subject, String template, Map<String,?> model);

    /**
     *  
     * @param recipient
     * @param subject
     * @param template
     * @param model
     */
    public void sendHTMLMessage(String recipient, String subject, String template, Map<String,?> model);
    
    /**
     * @param recipients
     * @param subject
     * @param template
     * @param model
     */
    public void sendHTMLMessage(String[] recipients, String subject, String template, Map<String,?> model);
    
    /**
     * @param msg
     */
    public void send(SimpleMailMessage msg);

}
