/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.mail.freemarker;

import java.io.StringWriter;
import java.util.Map;

import com.mysema.commons.mail.SimpleMailService;

import freemarker.template.Configuration;
import freemarker.template.DefaultObjectWrapper;
import freemarker.template.Template;

/**
 * FreeMarkerMailService provides
 *
 * @author tiwe
 * @version $Id$
 */
public class FreeMarkerMailService extends SimpleMailService{
    
    private Configuration cfg;
    
    public FreeMarkerMailService(){
        cfg = new Configuration();
        cfg.setClassForTemplateLoading(this.getClass(), "/");
        cfg.setObjectWrapper(new DefaultObjectWrapper());
    }
    
    protected String populateTemplate(String templateLocation, Map<String,?> model){               
        try {
            Template template = cfg.getTemplate(templateLocation);
            StringWriter writer = new StringWriter();
            template.process(model, writer);
            return writer.toString();
        } catch (Exception e) {            
            throw new RuntimeException(e);
        }        
    }

}
